# Canned responses

You can use the API to get or set canned response information.

The Canned respose model

| Key         | Type   | Description                                                              |
| ----------- | ------ | ------------------------------------------------------------------------ |
| id          | String | The unique identifier for the canned respose which is given by Tiledesk. |
| title       | String | The canned respose title.                                                |
| text        | String | The canned respose content                                               |
| attributes  | Object | The custom attributes which are set for the canned respose.              |
| createdAt   | String | The time (ISO-8601 date string) when the canned respose was created.     |
| updatedAt   | String | The time (ISO-8601 date string) when the canned respose was updated.     |
| createdBy   | String | The unique identifier of the row creator                                 |
| id\_project | String | The unique identifier of the project                                     |

## Get all canned responses

<mark style="color:blue;">`GET`</mark> `https://api.tiledesk.com/v3/:project_id/canned`

Allows an account to list all the canned responses.

#### Path Parameters

| Name        | Type   | Description                                                                              |
| ----------- | ------ | ---------------------------------------------------------------------------------------- |
| project\_id | string | the Project Id is a unique code assigned to your project when you create it in Tiledesk. |

#### Query Parameters

| Name      | Type   | Description                                                                                                                   |
| --------- | ------ | ----------------------------------------------------------------------------------------------------------------------------- |
| sortField | string | <p>what field to sort the results by.</p><p><em>Default field is createdAt</em></p>                                           |
| direction | string | <p>sort direction: 1 or -1. Return the results in ascending (1) or descending (-1) order.</p><p><em>defaults to desc</em></p> |
| page      | number | what page of results to fetch. defaults to first page.                                                                        |

#### Headers

| Name          | Type   | Description                                                 |
| ------------- | ------ | ----------------------------------------------------------- |
| Authorization | string | Authorization token. Basic Auth or JWT. Minumun role: agent |

{% tabs %}
{% tab title="200 " %}

```
[
   {
      "status":100,
      "_id":"5e67c1c89d86fa001755ed90",
      "title":"howcanhelpyou",
      "text":"Hi $recipient_name my name is $agent_name how can I help you?",
      "id_project":"5e5d40b2bd0a9b00179ff3cd",
      "createdBy":"5e09d16d4d36110017506d7f",
      "createdAt":"2020-03-10T16:35:20.458Z",
      "updatedAt":"2020-03-10T16:35:20.458Z",
      "__v":0
   },
   ...
]
```

{% endtab %}
{% endtabs %}

## Get a canned respose by id

<mark style="color:blue;">`GET`</mark> `https://api.tiledesk.com/v3/:project_id/canned/:id`

#### Path Parameters

| Name        | Type   | Description                                                                              |
| ----------- | ------ | ---------------------------------------------------------------------------------------- |
| id          | string | the canned identifier                                                                    |
| project\_id | string | The project\_id is a unique code assigned to your project when you create it in Tiledesk |

#### Headers

| Name          | Type   | Description                                                 |
| ------------- | ------ | ----------------------------------------------------------- |
| Authorization | string | Authorization token. Basic Auth or JWT. Minumun role: agent |
| Content-Type  | string | use "application/json" value                                |

{% tabs %}
{% tab title="200 " %}

```
{
      "status":100,
      "_id":"5e67c1c89d86fa001755ed90",
      "title":"howcanhelpyou",
      "text":"Hi $recipient_name my name is $agent_name how can I help you?",
      "id_project":"5e5d40b2bd0a9b00179ff3cd",
      "createdBy":"5e09d16d4d36110017506d7f",
      "createdAt":"2020-03-10T16:35:20.458Z",
      "updatedAt":"2020-03-10T16:35:20.458Z",
      "__v":0
   }
```

{% endtab %}
{% endtabs %}

## Create a new canned response

<mark style="color:green;">`POST`</mark> `https://api.tiledesk.com/v3/:project_id/canned`

#### Path Parameters

| Name        | Type   | Description                                                                              |
| ----------- | ------ | ---------------------------------------------------------------------------------------- |
| project\_id | string | The project\_id is a unique code assigned to your project when you create it in Tiledesk |

#### Headers

| Name          | Type   | Description                                                 |
| ------------- | ------ | ----------------------------------------------------------- |
| Authorization | string | Authorization token. Basic Auth or JWT. Minumun role: agent |
| Content-Type  | string | use "application/json" value                                |

#### Request Body

| Name       | Type   | Description                           |
| ---------- | ------ | ------------------------------------- |
| title      | string | the canned response title             |
| text       | string | the canned response content           |
| attributes | object | The canned response custom attributes |

{% tabs %}
{% tab title="200 " %}

```
{
      "status":100,
      "_id":"5e67c1c89d86fa001755ed90",
      "title":"howcanhelpyou",
      "text":"Hi $recipient_name my name is $agent_name how can I help you?",
      "id_project":"5e5d40b2bd0a9b00179ff3cd",
      "createdBy":"5e09d16d4d36110017506d7f",
      "createdAt":"2020-03-10T16:35:20.458Z",
      "updatedAt":"2020-03-10T16:35:20.458Z",
      "__v":0
   }
```

{% endtab %}
{% endtabs %}

## Update a canned response by id

<mark style="color:orange;">`PUT`</mark> `https://api.tiledesk.com/v3/:project_id/canned/:id`

#### Path Parameters

| Name        | Type   | Description                                                                              |
| ----------- | ------ | ---------------------------------------------------------------------------------------- |
| project\_id | string | The project\_id is a unique code assigned to your project when you create it in Tiledesk |
| id          | string | The id is the canned response indentifier.                                               |

#### Headers

| Name          | Type   | Description                                                 |
| ------------- | ------ | ----------------------------------------------------------- |
| Authorization | string | Authorization token. Basic Auth or JWT. Minumun role: agent |
| Content-Type  | string | use "application/json" value                                |

#### Request Body

| Name       | Type   | Description                           |
| ---------- | ------ | ------------------------------------- |
| title      | string | the canned response title             |
| text       | string | the canned response content           |
| attributes | object | The canned response custom attributes |

{% tabs %}
{% tab title="200 " %}

```
{
      "status":100,
      "_id":"5e67c1c89d86fa001755ed90",
      "title":"howcanhelpyou",
      "text":"Hi $recipient_name my name is $agent_name how can I help you?",
      "id_project":"5e5d40b2bd0a9b00179ff3cd",
      "createdBy":"5e09d16d4d36110017506d7f",
      "createdAt":"2020-03-10T16:35:20.458Z",
      "updatedAt":"2020-03-10T16:35:20.458Z",
      "__v":0
   }
```

{% endtab %}
{% endtabs %}

## Delete a canned response by id

<mark style="color:red;">`DELETE`</mark> `https://api.tiledesk.com/v3/:project_id/canned/:id`

#### Path Parameters

| Name        | Type   | Description                                                                              |
| ----------- | ------ | ---------------------------------------------------------------------------------------- |
| project\_id | string | The project\_id is a unique code assigned to your project when you create it in Tiledesk |
| id          | string | The id is the canned response indentifier.                                               |

#### Headers

| Name          | Type   | Description                                                 |
| ------------- | ------ | ----------------------------------------------------------- |
| Authorization | string | Authorization token. Basic Auth or JWT. Minumun role: agent |

{% tabs %}
{% tab title="200 " %}

```
{
      "status":100,
      "_id":"5e67c1c89d86fa001755ed90",
      "title":"howcanhelpyou",
      "text":"Hi $recipient_name my name is $agent_name how can I help you?",
      "id_project":"5e5d40b2bd0a9b00179ff3cd",
      "createdBy":"5e09d16d4d36110017506d7f",
      "createdAt":"2020-03-10T16:35:20.458Z",
      "updatedAt":"2020-03-10T16:35:20.458Z",
      "__v":0
   }
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://developer.tiledesk.com/apis/rest-api/canned-response.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
